//
//		Definition of the Achievement class
//
#ifndef ACHIEVEMENT_SCENE_H
#define ACHIEVEMENT_SCENE_H

#include "ldwScene.h"

class CAchievementsScene : public ldwScene
{
public:

	static CAchievementsScene *Get();
	static CAchievementsScene &Ref();
	static void              Destroy();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

	void Activate(bool active);

protected:

	static CAchievementsScene *m_pInstance;

	void DrawScene();
	void UpdateScene();

private:

	CAchievementsScene();
	~CAchievementsScene();

	enum
	{
		eButton_Done = 1,
		eButton_PageUp,
		eButton_PageDown
	};

	ldwRect  mScrollWindowRect;
	ldwRect  mScrollBarRect;
	ldwRect  mScrollKnobRect;

	bool mScrollKnobDrag;
	int  mScrollDragY;
	int  mScrollKnobMaxY;

	bool mHandScrollDrag;
	int  mHandScrollDragY;

	int mScrollPos;

	int mScrollAreaHeight;
	int mScrollableHeight;
};
#endif