/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Bath 
**
** DESCRIPTION:	Bath Restoration Puzzle
**
**      AUTHOR:	Arthur Humphrey, from template of Adrian Francis
**
\******************************************************************************/

#ifndef ConvertLastHeathenPUZZLE_H
#define ConvertLastHeathenPUZZLE_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwImage.h"
#include "PuzzleInterface.h"
#include "../Game/theGameState.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/

//const ldwPoint Fruitwells_c_sCenter(114, 1802);

enum EConvertLastHeathenStatus
{
	eConvertLastHeathen_InitialState = 0,

	eConvertLastHeathen_NumberOfStates

};

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CConvertLastHeathenPuzzle : public IPuzzle
{
	friend class CPuzzle;

public:

	CConvertLastHeathenPuzzle(void);



	EConvertLastHeathenStatus m_eConvertLastHeathenStatus;

	void Reset();

	const int	LoadState(const unsigned char *pData);
	const int	SaveState(const unsigned char *pData, const int iMaxDataSize) const;
	bool		AdvancePuzzleState();
	EConvertLastHeathenStatus	 GetStatus();
	int GetPercentComplete();

	void Draw() const;
	

	void		Draw(const int iRef);
	const int SaveStateSize() {return sizeof (SSaveState);}
	void		LoadAssets();
	void		ReleaseAssets();

	// process
	void Refresh();
	void Update();
	void Advance(CVillager &Villager, const int iRef);
	void Advance();
	void Complete();

	// access

private:
	

	//class structures
	struct SSaveState
	{
		//EConvertLastHeathenStatus	m_eConvertLastHeathenStatus;
	//	int					m_iConvertLastHeathenProgress;
	};
	
	int m_iConvertLastHeathenProgress;
	ldwImageGrid *  m_pNecklacePiece;
	ldwImage *  m_pHovelColver;

	//class data
	
	theGameState  *gs;
	bool diagProp;

};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CConvertLastHeathenPuzzle		ConvertLastHeathenPuzzle;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/