/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Bath 
**
** DESCRIPTION:	Bath Restoration Puzzle
**
**      AUTHOR:	Arthur Humphrey, from template of Adrian Francis
**
\******************************************************************************/

#ifndef ConvertMasterBuilderPUZZLE_H
#define ConvertMasterBuilderPUZZLE_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwImage.h"
#include "PuzzleInterface.h"
#include "../Game/theGameState.h"
#include "../Puzzles/ConvertHeathenChiefPuzzle.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/

//const ldwPoint Fruitwells_c_sCenter(114, 1802);

enum EConvertMasterBuilderStatus
{
	eConvertMasterBuilder_InitialState = 0,

	eConvertMasterBuilder_NumberOfStates

};

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CConvertMasterBuilderPuzzle : public IPuzzle
{
	friend class CPuzzle;

public:

	CConvertMasterBuilderPuzzle(void);



	EConvertMasterBuilderStatus m_eConvertMasterBuilderStatus;

	void Reset();

	const int	LoadState(const unsigned char *pData);
	const int	SaveState(const unsigned char *pData, const int iMaxDataSize) const;
	bool		AdvancePuzzleState();
	EConvertMasterBuilderStatus	 GetStatus();
	int GetPercentComplete();

	void Draw() const;
	

	void		Draw(const int iRef);
	const int SaveStateSize() {return sizeof (SSaveState);}
	void		LoadAssets();
	void		ReleaseAssets();

	// process
	void Refresh();
	void Update();
	void Advance(CVillager &Villager, const int iRef);
	void Advance(EConvertMasterBuilderStatus currentStatus);
	void Complete();

	// access

private:
	

	//class structures
	struct SSaveState
	{
		EConvertMasterBuilderStatus	m_eConvertMasterBuilderStatus;
		int					m_iConvertMasterBuilderProgress;
	};
	
	int m_iConvertMasterBuilderProgress;
	
	//class data
	
	theGameState  *gs;

	ldwImageGrid *	m_pBuildingWood;

	ldwImageGrid *	m_pTotem;

	ldwImageGrid *  m_pNecklacePiece;
};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CConvertMasterBuilderPuzzle		ConvertMasterBuilderPuzzle;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/