//
//		Class definition for the God Power butterflies
//

#ifndef THE_GODPOWER_BUTTERFLY_CLASS_H
#define THE_GODPOWER_BUTTERFLY_CLASS_H

#include "ldwTypes.h"

class ldwGameWindow;
class ldwImageGrid;

class CGodPowerButterflyClass 
{
public:

	static CGodPowerButterflyClass * Get();
	static void Destroy();

	bool SpawnButterflies(int howMany,ldwPoint spawnPoint,ldwPoint targetPoint,int targetRadius);
	void DisperseButterflies();

	void ClearButterflies() {InitButterflies();}

	ldwPoint GetRandomButterflyLocation();

	void Update();
	void Draw();

protected:
	
	enum
	{
		maxNumGPButterflies  = 50,
		defaultGPButterflyAnimSpeed =	2,
		eGBPMaxVelocity = 2,
		numGPButterflySets = 5
	};			  
			  
	typedef enum
	{
		eGPBChasing,
		eGPBLanding,
		eGPBSunning,
		eGPBFluttering,
		eGPBFollowingVillager,
		eGPBPolinating,
		eGPBNotExisting

	}
	GPButterflyStateType;

	typedef struct
	{
		bool exists;
		int xPos;
		int yPos;
		int xTarget;
		int yTarget;
		int landingTargetX;
		int landingTargetY;
		int xVel;
		int yVel;
		int type;
		int wingPosition;
		int wingMotionIdx;
		int scale;
		GPButterflyStateType butterflyState;
		ldwPoint groupTarget;
	}
	GPButterflyType;

	CGodPowerButterflyClass();
	~CGodPowerButterflyClass();

	void AcquireTarget(int whichButterfly, int x, int y);
	void InitButterflies();

	void SetGroupTarget(int x, int y);
	void SetGroupDefaultTarget(int x, int y);
	bool CheckNearButterflies(ldwPoint checkPoint);
	void ChooseNewBehavior();

	GPButterflyStateType GetState(){return butterflies[0].butterflyState;}
	void ChangeState(GPButterflyStateType whatState);

	GPButterflyType butterflies[maxNumGPButterflies];

	static CGodPowerButterflyClass *mInstance;

	int mTargetRadius;
	bool mDispersing;
	int mFrame;
	int mButteflyCount;

	ldwImageGrid *butterflyGrid;
	ldwPoint groupDefaultTarget;

	int groupIndexCounter;
	int groupIndexTrigger;

	ldwGameWindow *gameWindow;
};


/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/

#endif
