/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Pages
**
** DESCRIPTION:	Story pages
**
**
\******************************************************************************/

#ifndef PAGES_H
#define PAGES_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "PageInterface.h"

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CIntroPage1 : public IPage
{
public:

	void 	   Enter();
	void 	   Exit();
	const bool FadeImage();
	const bool FadeOut();

private:

	int			m_iTimer;
	int			m_iBackgroundImage;
};

class CIntroPage2 : public IPage
{
public:

	void 	   Enter();
	void 	   Exit();
	const bool FadeImage();
	void 	   FadeImageSkipped();
	void		FadeText();
	const bool FadeOut();

private:

	int			m_iTimer;
	int			m_iBackgroundImage;
	bool		m_bHasPlayedDrums;
};

class CIntroPage3 : public IPage
{
public:

	void 	   Enter();
	void		Exit();
	const bool FadeImage();
	void 	   FadeImageSkipped();
	const bool FadeOut();

private:

	int			m_iBackgroundImage;
};

class CIntroPage5 : public IPage
{
public:

	void 	   Enter();
	void 	   Exit();
	const bool FadeImage();
	void		FadeText();
	void 	   FadeImageSkipped();
	void 	   Update();
	const bool FadeOut();

private:

	int			m_iBackgroundImage;
	int			m_iMaskingImage;
	bool		m_bIsPlayingBranchTear;
	bool		m_bHasPlayedDrums;
	bool		m_bIsAmbushed;
};

class CMidGamePage1 : public IPage
{
public:

	void       Enter();
	const bool FadeImage();
	const bool FadeOut();

private:

	int	 m_iBackgroundImage;
};

class CMidGamePage2 : public IPage
{
public:

	void Enter();
	const bool FadeImage();
	const bool FadeOut();

private:

	int			m_iBackgroundImage;
};

class CMidGamePage3 : public IPage
{
public:

	void  	   Enter();
	void		Exit();
	const bool FadeImage();
	const bool FadeOut();

private:

	int		m_iBackgroundImage;
};

class CMidGamePage4 : public IPage
{
public:

	void  	   Enter();
	void		Exit();
	void		FadeText();
	const bool FadeImage();
	const bool FadeOut();

private:

	int		m_iBackgroundImage;
};
class CMidGamePage5 : public IPage
{
public:

	void  	   Enter();
	void		Exit();
	const bool FadeImage();
	const bool FadeOut();

private:

	int		m_iBackgroundImage;
};

class CEndGamePage1 : public IPage
{
public:

	void 	   Enter();
	const bool FadeImage();
	const bool FadeOut();

private:

	int			m_iBackgroundImage;
};

class CEndGamePage2 : public IPage
{
public:

	void Enter();
	const bool FadeImage();
	const bool FadeOut();

private:

	int			m_iBackgroundImage;
};

class CEndGamePage3 : public IPage
{
public:

	void 	   Enter();
	void		Exit();
	const bool FadeImage();
	void 	   FadeImageSkipped();
	void		FadeText();
	const bool FadeOut();

private:

	int	m_iBackgroundImage;
};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CIntroPage1		IntroPage1;
extern CIntroPage2		IntroPage2;
extern CIntroPage3		IntroPage3;
extern CIntroPage5		IntroPage5;
extern CMidGamePage1	MidGamePage1;
extern CMidGamePage2	MidGamePage2;
extern CMidGamePage3	MidGamePage3;
extern CMidGamePage4	MidGamePage4;
extern CMidGamePage5	MidGamePage5;
extern CEndGamePage1	EndGamePage1;
extern CEndGamePage2	EndGamePage2;
extern CEndGamePage3	EndGamePage3;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/