/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	StoryScene
**
** DESCRIPTION:	Story telling scene
**
**
\******************************************************************************/

#ifndef STORY_SCENE_H
#define STORY_SCENE_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwScene.h"
#include "ldwButton.h"

class ldwTextControl;

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CStoryScene : public ldwScene
{
public:

	static CStoryScene *Get();
	static CStoryScene &Ref();
	static void Destroy();

	CStoryScene(const CStoryScene &);
	CStoryScene & operator = (const CStoryScene &);

	void Activate(bool bIsActive);

	void DrawScene();
	void UpdateScene();

	bool HandleMessage(int iMessageID, long iData);
	bool HandleMouse(int iMessageID, ldwPoint sMousePos);

	void AddTutorialTipButtons();
	void RemoveSkipButton();
	void AddSkipButton();	 

	void DisplayClickLabel();
	void RemoveClickLabel();
			
private:

	CStoryScene();
	~CStoryScene();

	enum EButton
	{
		eButton_Skip = 0,
		eButton_Yes,
		eButton_No,

		eButton_NumberOf
	};

	//class data
	static CStoryScene *	m_pInstance;

	ldwButton *				m_pButton[eButton_NumberOf];
	ldwTextControl *		clickLabel;
	bool					m_bAreTutorialTipButtonsShown;

	//class methods
	//setup
};

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/