//
//		Definition of the main game class
//
#ifndef THE_PUZZLES_SCENE_H
#define THE_PUZZLES_SCENE_H


#include "ldwScene.h"
#include "../World/WorldMap.h"
#include "ldwGameWindow.h"
#include "ldwImage.h"
#include "../Utils/theStringManager.h"

class ldwButton;
class ldwSoundTrack;
class ldwSoundFx;
class theGameState;
class ldwTextControl;
class theSoundManager;

class thePuzzlesScene : public ldwScene
{
public:

	thePuzzlesScene();
	~thePuzzlesScene();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);
	bool ForwardWaitingMessage(StringId whichMessage);
	
	static thePuzzlesScene *Get();
	static thePuzzlesScene &Ref();
	static void              Destroy();

protected:
	static thePuzzlesScene *m_pInstance;
	void DrawScene();
	void UpdateScene();

private:

	ldwGameWindow *gameWindow;
	theGameState  *gs;
	theSoundManager *soundMgr;
	theStringManager *stringMgr;
	ldwTextControl *		m_pPlayerCommField;

	int handAdjX;
	int handAdjY;

	bool fullScreenMode;
	bool pointerShowing;

	ldwRect displayRect;

	ldwRect puzzle1Rect;
	ldwRect puzzle2Rect;
	ldwRect puzzle3Rect;
	ldwRect puzzle4Rect;
	ldwRect puzzle5Rect;
	ldwRect puzzle6Rect;
	ldwRect puzzle7Rect;
	ldwRect puzzle8Rect;
	ldwRect puzzle9Rect;
	ldwRect puzzle10Rect;
	ldwRect puzzle11Rect;
	ldwRect puzzle12Rect;
	ldwRect puzzle13Rect;
	ldwRect puzzle14Rect;
	ldwRect puzzle15Rect;
	ldwRect puzzle16Rect;
	ldwRect puzzle17Rect;


	ldwImage *BG;
	ldwImage *BGPics;
	ldwImageGrid *puzzleCovers;

	ldwTextControl *sceneLabel;

	const int doneButtonId;
	const int statsButtonId;
	const int collectionsButtonId;

	ldwButton      *doneButton;
	ldwButton		*statsButton;
	ldwButton		*collectionsButton;

	bool customCursor;
	bool hideCursor;
};
#endif